<?
// A simple XML responder. It echoes a flattened list of the elements it receives.

  $theElements=array();
  $oldElements=array();
  $thisElement="";

function startElement($parser, $name, $attribs ) {
   global $thisElement, $oldElements, $theElements;
   array_push( $oldElements, $thisElement);
   $thisElement=$name;
   $theElements[ $thisElement ] = "";

}

function endElement($parser, $name) {
   global $thisElement, $oldElements;
   $thisElement= array_pop( $oldElements);
}

function characterData($parser, $text) {
   global $thisElement, $theElements;
   $theElements[ $thisElement ] .= $text;
}

function unknownXML(  $parser, $stuff) {
    echo "What is this stuff? ($stuff)<br/>";
}




global $HTTP_RAW_POST_DATA;

$xml_parser = xml_parser_create();
xml_set_element_handler(       $xml_parser, "startElement", "endElement");
xml_set_character_data_handler($xml_parser, "characterData");
xml_set_default_handler(       $xml_parser, "unknownXML");

if (!xml_parse($xml_parser, $HTTP_RAW_POST_DATA, true ))
     die("XML error: xml_error_string(xml_get_error_code($xml_parser))
             at line xml_get_current_line_number($xml_parser))" );
xml_parser_free($xml_parser);

              
header( "Content-type: text/xml");
reset( $theElements );
echo "<RESPONSE>"; 
while (list($elementName, $elementContent) = each( $theElements ) )  
   echo "<$elementName>$elementContent</$elementName>"; 
echo "</RESPONSE>"; 
       
?>
